<?php

if (!isset($autosocial) || $autosocial !== true) die('no direct access');

/*
 *  Facebook connect message
 */
if (isset($_GET['reset'])) {

   // Settings
   delete_option('autosocial_box');
   delete_option('autosocial_auto');

   // Twitter
   delete_option('tw_enabled');
   delete_option('tw_pattern');
   delete_option('tw_consumerkey');
   delete_option('tw_consumersecret');
   delete_option('tw_oauthtoken');
   delete_option('tw_oauthsecret');

   // Facebook
   delete_option('fb_enabled');
   delete_option('fb_pattern');
   delete_option('fb_appid');
   delete_option('fb_appsecret');
   delete_option('fb_page_id');

   // Info
   echo '<div class="updated settings-error"><p><strong>'.__('Settings has been reset.', 'wp-autosocial').'</strong></p></div>';
}

/*
 *  Facebook connect message
 */
if (isset($_GET['fb_connect'])) {
   if ($_GET['fb_connect'] == 1) {
      echo '<div class="updated settings-error"><p><strong>'.__('Facebook connected successfully.', 'wp-autosocial').'</strong></p></div>';
   } else {
      echo '<div class="error settings-error"><p><strong>'.__('Facebook not connected!', 'wp-autosocial').'</strong></p></div>';
   }
}

/*
 *  Testing connections
 */
// Twitter
if (isset($_GET['tw_test'])) {
   $link = autosocial_twitter(0, 'Testing #wpautosocial : share to #twitter and #facebook from #wordpress', 'http://capo.cat/wp-autosocial/');
   echo '<div class="updated settings-error"><p><strong>'.__('Twitter connection tested.', 'wp-autosocial').'</strong> <a href="'.$link.'">'.__('Link').'</a></p></div>';
}
// Facebook
if (isset($_GET['fb_test'])) {
   $link = autosocial_facebook(0, 'Testing WP-Autosocial Plugin', 'Share to Twitter and Facebook your published posts in your Wordpress blog!', 'http://capo.cat/wp-autosocial/');
   echo '<div class="updated settings-error"><p><strong>'.__('Facebook connection tested.', 'wp-autosocial').'</strong> <a href="'.$link.'">'.__('Link').'</a></p></div>';
}



/*
 *  Save settings
 */
if (isset($_POST['submit'])) {

   // Settings
   if ($_POST['autosocial_box'] == 'on')
      update_option('autosocial_box', 1);
   else
      update_option('autosocial_box', 0);

   if ($_POST['autosocial_auto'] == 'on')
      update_option('autosocial_auto', 1);
   else
      update_option('autosocial_auto', 0);

   // Twitter
   if ($_POST['tw_enabled'] == 'on')
      update_option('tw_enabled', 1);
   else
      update_option('tw_enabled', 0);

   update_option('tw_pattern', $_POST['tw_pattern']);
   update_option('tw_consumerkey', $_POST['tw_consumerkey']);
   update_option('tw_consumersecret', $_POST['tw_consumersecret']);
   update_option('tw_oauthtoken', $_POST['tw_oauthtoken']);
   update_option('tw_oauthsecret', $_POST['tw_oauthsecret']);

   // Facebook
   if ($_POST['fb_enabled'] == 'on')
      update_option('fb_enabled', 1);
   else
      update_option('fb_enabled', 0);

   update_option('fb_pattern', $_POST['fb_pattern']);
   update_option('fb_appid', $_POST['fb_appid']);
   update_option('fb_appsecret', $_POST['fb_appsecret']);
   update_option('fb_page_id', $_POST['fb_page_id']);

   // Info
   echo '<div class="updated settings-error"><p><strong>'.__('Settings saved.', 'wp-autosocial').'</strong></p></div>';

}

/*
 *  Get defaults settings
 */

// Twitter
if (get_option('tw_pattern') == '') {
   update_option('tw_pattern', '#title# - #link# #wpautosocial');
}

// Facebook
$fb_pattern = get_option('fb_pattern');
if (get_option('fb_pattern') == '') {
   update_option('fb_pattern', 'New post: #title#');
}
if (get_option('fb_appid') == '' || get_option('fb_appsecret') == '') {
   update_option('fb_token', '');
   update_option('fb_page_id', '');
}

// Get Facebook page with the user token
if (get_option('fb_token') != '') {
   $fb_pages = json_decode(graph('https://graph.facebook.com/me/accounts?access_token='.get_option('fb_token')), true);
   if (isset($fb_pages['data']))
      $fb_pages = $fb_pages['data'];
   else {
      unset($fb_pages);
      $fb_token = '';
   }
}

?>
<form action="<?php echo $plugin_url; ?>" method="post">

   <div class="postbox">
      <h3 class="hndle"><?php _e('Global Settings', 'wp-autosocial'); ?></h3>
      <div class="inside">

         <table class="form-table" style="clear:none">

            <tr valign="top">
               <th scope="row"><label for="autosocial_box"><?php _e('Display WP-Autosocial meta', 'wp-autosocial'); ?></label></th>
               <td>
                  <input name="autosocial_box" type="checkbox" id="autosocial_box"<?php echo (get_option('autosocial_box') == 1 ? ' checked="checked"' : ''); ?> />
                  <em><?php _e('<a href="./post-new.php">Post page</a> metabox with information and send option.', 'wp-autosocial'); ?></em>
               </td>
            </tr>

            <tr valign="top">
               <th scope="row"><label for="autosocial_auto"><?php _e('Autopublish posts', 'wp-autosocial'); ?></label></th>
               <td>
                  <input name="autosocial_auto" type="checkbox" id="autosocial_auto"<?php echo (get_option('autosocial_auto') == 1 ? ' checked="checked"' : ''); ?> />
                  <em><?php _e('Automatically publish post to Facebook and Twitter (future post allowed).', 'wp-autosocial'); ?></em>
               </td>
            </tr>

         </table>
      </div>
   </div>

   <div class="postbox">
      <h3 class="hndle">Twitter</h3>
      <div class="inside">

         <p>
            <label for="tw_enabled"><?php _e('Enable', 'wp-autosocial'); ?></label>
            <input name="tw_enabled" type="checkbox" id="tw_enabled"<?php echo (get_option('tw_enabled') == 1 ? ' checked="checked"' : ''); ?> />
         </p>

         <div id="tw_box"<?php echo (get_option('tw_enabled') == 1 ? '': ' style="display:none"'); ?>>

            <ol>
               <li><?php _e('Go to <a href="https://dev.twitter.com/apps">Twitter Developers</a> and create a new app with <strong>read and write</strong> access.', 'wp-autosocial'); ?></li>
            </ol>

            <table class="form-table" style="clear:none">

               <tr valign="top">
                  <th scope="row"><label for="tw_pattern"><?php _e('Pattern', 'wp-autosocial'); ?></label></th>
                  <td>
                     <input name="tw_pattern" type="text" id="tw_pattern" class="regular-text" value="<?php echo get_option('tw_pattern'); ?>" />
                     <em><?php _e('Fields', 'wp-autosocial'); ?>: #title#, #link#</em>
                  </td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="tw_consumerkey">Consumer Key</label></th>
                  <td><input name="tw_consumerkey" type="text" id="tw_consumerkey" class="regular-text" value="<?php echo get_option('tw_consumerkey'); ?>" /></td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="tw_consumersecret">Consumer Secret</label></th>
                  <td><input name="tw_consumersecret" type="text" id="tw_consumersecret" class="regular-text" value="<?php echo get_option('tw_consumersecret'); ?>" /></td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="tw_oauthtoken">OAuth Token</label></th>
                  <td><input name="tw_oauthtoken" type="text" id="tw_oauthtoken" class="regular-text" value="<?php echo get_option('tw_oauthtoken'); ?>" /></td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="tw_oauthsecret">OAuth Secret</label></th>
                  <td><input name="tw_oauthsecret" type="text" id="tw_oauthsecret" class="regular-text" value="<?php echo get_option('tw_oauthsecret'); ?>" /></td>
               </tr>

            </table>

            <?php if(get_option('tw_consumerkey') != '' && get_option('tw_consumersecret') != '' && get_option('tw_oauthsecret') != '' && get_option('tw_oauthtoken') != ''): ?>
            <p><a href="<?php echo $plugin_url; ?>&tw_test" class="button-secondary"><?php _e('Test!', 'wp-autosocial'); ?></a></p>
            <?php else: ?>
            <div class="error settings-error"><p><strong>Twitter:</strong> <?php _e('Configuration missing!', 'wp-autosocial'); ?></p></div>
            <?php endif;?>

         </div><!-- tw_box -->
      </div>
   </div>


   <div class="postbox">
      <h3 class="hndle">Facebook</h3>
      <div class="inside">

         <p>
            <label for="fb_enabled"><?php _e('Enable', 'wp-autosocial'); ?></label>
            <input name="fb_enabled" type="checkbox" id="fb_enabled"<?php echo (get_option('fb_enabled') == 1 ? ' checked="checked"' : ''); ?> />
         </p>

         <div id="fb_box"<?php echo (get_option('fb_enabled') == 1 ? '': ' style="display:none"'); ?>>

            <ol>
               <li><?php _e('Go to <a href="https://developers.facebook.com/apps">Facebook Developers</a> and create a new website app with <strong>Site URL</strong> set to your domain.', 'wp-autosocial'); ?></li>
               <li><?php _e('Set the <strong>App ID</strong> and <strong>App Secret</strong> fields.', 'wp-autosocial'); ?></li>
               <li><?php _e('Get the token for your user.', 'wp-autosocial'); ?></li>
               <li><?php _e('If you want, select a destination page.', 'wp-autosocial'); ?></li>
            </ol>
            <table class="form-table" style="clear:none">

               <tr valign="top">
                  <th scope="row"><label for="fb_pattern"><?php _e('Pattern', 'wp-autosocial'); ?></label></th>
                  <td>
                     <input name="fb_pattern" type="text" id="fb_pattern" class="regular-text" value="<?php echo get_option('fb_pattern'); ?>" />
                     <em><?php _e('Fields', 'wp-autosocial'); ?>: #title#</em>
                  </td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="fb_appid">App ID</label></th>
                  <td><input name="fb_appid" type="text" id="fb_appid" class="regular-text" value="<?php echo get_option('fb_appid'); ?>" /></td>
               </tr>

               <tr valign="top">
                  <th scope="row"><label for="fb_appsecret">App Secret</label></th>
                  <td><input name="fb_appsecret" type="text" id="fb_appsecret" class="regular-text" value="<?php echo get_option('fb_appsecret'); ?>" /></td>
               </tr>

               <?php if (get_option('fb_appid') != '' && get_option('fb_appsecret') != ''): ?>
               <tr valign="top">
                  <th scope="row"><label for="fb_token">Token</label></th>
                  <td>
                     <?php if (get_option('fb_token') != '') : ?>
                     <input name="fb_token" type="text" id="fb_token" class="regular-text" value="<?php echo get_option('fb_token'); ?>" readonly="readonly" />
                     <?php endif; ?>
                     <a href="https://graph.facebook.com/oauth/authorize?client_id=<?php echo get_option('fb_appid'); ?>&redirect_uri=<?php echo urlencode($fb_url); ?>&scope=<?php echo $fb_permisos; ?>">
                        <?php _e('Get token!', 'wp-autosocial'); ?>
                     </a>
                  </td>
               </tr>
               <?php endif; ?>

               <?php if (isset($fb_pages)): ?>
               <tr valign="top">
                  <th scope="row"><label for="fb_page_id"><?php _e('Destination', 'wp-autosocial'); ?></label></th>
                  <td>
                     <select id="fb_page_id" name="fb_page_id">
                        <option value=""><?php _e('My profile', 'wp-autosocial'); ?></option>
                        <?php $fb_cat = ''; foreach($fb_pages as $fb_page) : ?>
                           <?php if ($fb_cat != $fb_page['category']) : ?>
                              <?php if ($fb_cat != '') : ?></optgroup><?php endif; ?>
                              <optgroup label="<?php echo $fb_page['category']; ?>">
                           <?php $fb_cat = $fb_page['category']; endif; ?>
                           <option value="<?php echo $fb_page['id']; ?>"<?php echo (get_option('fb_page_id') == $fb_page['id'] ? ' selected="selected"' : ''); ?>>
                              <?php echo $fb_page['name']; ?>
                           </option>
                        <?php endforeach; ?>
                        <?php if ($fb_cat != '') : ?></optgroup><?php endif; ?>
                     </select>
                  </td>
               </tr>
               <?php endif; ?>

            </table>

            <?php if(get_option('fb_token') != ''): ?>
            <p><a href="<?php echo $plugin_url; ?>&fb_test" class="button-secondary"><?php _e('Test!', 'wp-autosocial'); ?></a></p>
            <?php else: ?>
            <div class="error settings-error"><p><strong>Facebook:</strong> <?php _e('Configuration missing!', 'wp-autosocial'); ?></p></div>
            <?php endif;?>

         </div><!-- fb_box -->
      </div>
   </div>

   <p class="submit">
      <input type="submit" name="submit" value="<?php _e('Save Changes', 'wp-autosocial'); ?>" class="button-primary" />
      <a href="<?php echo $plugin_url; ?>&reset" class="button-secondary"><?php _e('Reset', 'wp-autosocial'); ?></a>
   </p>
</form>
